-- projekt: generator signala z merilnikom, DES 2024/25
-- generiraj sinusni signal in prikazi frekvenco na LED

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity gensig is
 port (
   clk  : in std_logic;
   data : in unsigned(7 downto 0);
	clkout: out std_logic;
	addr : out unsigned(1 downto 0);	
   led  : out unsigned(7 downto 0) );
end gensig;

architecture RTL of gensig is
 signal clk1  : std_logic;
 signal data1 : signed(7 downto 0);
 signal div : unsigned(7 downto 0) := to_unsigned(0,8); 
 signal korak : unsigned(15 downto 0) := to_unsigned(1000, 16);
 signal tipke : unsigned(3 downto 0);
begin

-- vmesnik za branje tipk (S1-S4)
clkout <= clk;
addr   <= "01";
tipke  <= data(3 downto 0);

-- deljenje sistemske ure 50 MHz na 100 kHz (clk1)
process(clk)
begin
 if rising_edge(clk) then
  if div = 249 then
     div <= (others=>'0');
     clk1 <= not clk1;
  else
     div <= div + 1;
  end if;
 end if;
end process;

-- nastavi korak s tipkami...

-- generator sinusa z nastavljenim korakom
u1: entity work.gen port map(
	clk => clk1,	 
	korak => korak,
	data => data1
);

-- merilnik frekvence
u2: entity work.merilnik port map(
	clk => clk1,
	data => data1,
	f => led
);

end RTL;